#ifndef ADOC_SEM_H
#define ADOC_SEM

#ifdef USE_IPC /*my own semaphore library with IPC SYS_V semaphore*/ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>

#define adoc_sem int

int  adoc_sem_init(int  *id,  int  pshared,   unsigned   int val);
int adoc_sem_wait(int * id);
int adoc_sem_post(int * id);
int adoc_sem_getvalue(int * id, int * sval);
int adoc_sem_destroy(int * id);


#else /*my own semaphore library with condition varaibales*/
#include <pthread.h>
#include <stdlib.h>

typedef struct{
    int val;
    pthread_mutex_t mutex;
    pthread_cond_t cond;
}adoc_sem;
int  adoc_sem_init(adoc_sem *sem,  int  pshared,   unsigned   int val);
int adoc_sem_wait(adoc_sem *sem);
int adoc_sem_post(adoc_sem *sem);
int adoc_sem_getvalue(adoc_sem *sem, int * sval);
int adoc_sem_destroy(adoc_sem *sem);
#endif/*USE_IPC*/
#endif /*ADOC_SEM_H*/

