#ifndef EMISION_H
#define EMISION_H
#include "common.h"
#include "timings.h"
#include "adoc.h"

typedef struct{
    int socket;
    FILE *file;
    byte * data_buffer;
    size_t data_size;
    size_t file_size;
    size_t sent_size;
    size_t uncomp_size;
    byte max_level;
    byte min_level;
    adoc_sem r_sem,w_sem,history_sem;
    /* ADOC_data_window is a cyclic window for storing data, with
        one wrinting pointer (where are stored compressed and uncompressed data*/
    byte *data_window,*data_w_pointer;
    header *header_window;
    unsigned int header_r,header_w;
    size_t fifo_size;
    pthread_mutex_t fifo_mutex;
    int error;
    double *speed_min; /*minimal speed for each compression level in Mbit/s*/
    int * reset_speed_min; /*minimal speed for each compression level in Mbit/s*/
    CLOCK_T time_stamp; /*time stamp of the last reset of speed_min table*/
    
}ADOC_session;

ssize_t launch_threads(int socket, byte *data_buffer,
                      size_t data_size,
                      size_t *sent_size,unsigned int min_level,unsigned int max_level);
void *data_compression_thread (void *arg);
void *file_compression_thread (void *arg);
void *emission_thread(void *arg);

ssize_t launch_em_threads(int socket, byte *data_buffer,
                      size_t data_size,
                      size_t *sent_size,unsigned int min_level,unsigned int max_level);
/*ssize_t raw_send(int socket, byte *data_buffer,
                 size_t data_size,
                 size_t *sent_size);
ssize_t raw_send_in_pieces(int socket, byte *data_buffer,
                           size_t data_size,
                           size_t *sent_size,
                           int nb_pieces,
                           size_t pieces_size);
*/
#undef DEBUG
#undef DEBUG_TIMEOUT
#undef VERBOSE
#undef DUMP_PACKET
#define ADOC_MAX_SEND_PACKETS (ADOC_MAX_NB_PACKETS+1+(2*LZF_BUFFER_SIZE)/ADOC_PACKET_SIZE)

/* Network bandwith above which no compression is perfromed*/
#define CMP_THRESHOLD 500 /*in Mbit/s*/

#endif /*EMISION_H*/

